(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "react", "react-universal-component", "@reach/router", "../../app-dir/reach-utils", "../../app-dir/utils"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("react"), require("react-universal-component"), require("@reach/router"), require("../../app-dir/reach-utils"), require("../../app-dir/utils"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.reactUniversalComponent, global.router, global.reachUtils, global.utils);
    global.index = mod.exports;
  }
})(this, function (_exports, _react, _reactUniversalComponent, _router, _reachUtils, _utils) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = ChidoLink;
  _react = _interopRequireDefault(_react);
  _reactUniversalComponent = _interopRequireDefault(_reactUniversalComponent);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  (function () {
    var enterModule = require('react-hot-loader').enterModule;

    enterModule && enterModule(module);
  })();

  function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

  function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

  function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

  var getChunkName = function getChunkName(to) {
    var simpleTo = to[0] === '/' && to !== '/' ? to.substr(1) : to;
    simpleTo = to === '/' ? to : "".concat(simpleTo, "/");
    var chunkName = window.__fullRoutes[simpleTo];
    chunkName = chunkName || window.__fullRoutes[to];
    return chunkName;
  };

  var tryPrefetch = function tryPrefetch(to) {
    if (_utils.isDev) {
      return null;
    }

    var chunkName = getChunkName(to);
    var importFn = window.__asyncChunks[chunkName];

    if (!importFn) {
      var routesArr = window.__dynamicRoutes.map(function (obj) {
        return {
          path: obj.route,
          chunkName: obj.chunkName
        };
      });

      var dynamicRoute = (0, _reachUtils.pick)(routesArr, to);

      if (dynamicRoute) {
        importFn = window.__asyncChunks[dynamicRoute.route.chunkName];
      }
    }

    return importFn;
  };

  function ChidoLink(fullprops) {
    var to = fullprops.to,
        _onClick = fullprops.onClick,
        _onMouseEnter = fullprops.onMouseEnter,
        props = _objectWithoutProperties(fullprops, ["to", "onClick", "onMouseEnter"]);

    return _react.default.createElement(_router.Link, _extends({
      to: to,
      onMouseEnter: function onMouseEnter(e) {
        _onMouseEnter && _onMouseEnter(e);
        var importFn = tryPrefetch(to);

        if (importFn) {
          (0, _reactUniversalComponent.default)(importFn).preload();
        }
      },
      onClick: function onClick(event) {
        _onClick && _onClick(event);

        if (event.button === 0 // ignore right clicks
        && !props.target // let browser handle "target=_blank"
        && !event.defaultPrevented // onClick prevented default
        && !event.metaKey // ignore clicks with modifier keys...
        && !event.altKey && !event.ctrlKey && !event.shiftKey) {
          event.preventDefault();
          var importFn = tryPrefetch(to);

          if (importFn) {
            // What happen if the promise gets rejected?
            (0, _reactUniversalComponent.default)(importFn).preload().then(function () {
              return (0, _router.navigate)(to);
            });
          } else {
            (0, _router.navigate)(to);
          }
        }
      }
    }, props));
  }

  ;

  (function () {
    var reactHotLoader = require('react-hot-loader').default;

    var leaveModule = require('react-hot-loader').leaveModule;

    if (!reactHotLoader) {
      return;
    }

    reactHotLoader.register(getChunkName, "getChunkName", "/home/martiuh/Sites/chido/src/chido-link/index.js");
    reactHotLoader.register(tryPrefetch, "tryPrefetch", "/home/martiuh/Sites/chido/src/chido-link/index.js");
    reactHotLoader.register(ChidoLink, "ChidoLink", "/home/martiuh/Sites/chido/src/chido-link/index.js");
    leaveModule(module);
  })();

  ;
});