(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define([], factory);
  } else if (typeof exports !== "undefined") {
    factory();
  } else {
    var mod = {
      exports: {}
    };
    factory();
    global.ensureDirs = mod.exports;
  }
})(this, function () {
  "use strict";

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

  function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

  var fse = require('fs-extra');

  var rimraf = require('rimraf');

  var slash = require('slash');

  var buildChunks = require('../routes-generator/build-chunks');

  var report = require('../report');

  module.exports =
  /*#__PURE__*/
  function () {
    var _ensureDirs = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      var processDir, appDir, appDirExists, dotAppDir, dotAppDirExists, copiedSuccess, publicDir, publicDirExists;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              processDir = process.cwd();
              appDir = slash("".concat(__dirname, "/../../app-dir/"));
              report.info('searching for app-dir');
              _context.next = 5;
              return fse.pathExists(appDir);

            case 5:
              appDirExists = _context.sent;

              if (appDirExists) {
                _context.next = 8;
                break;
              }

              throw new Error('There\'s a problem with your "chido" installation, please "npm uninstall chido" and then run "npm install chido" again!!!');

            case 8:
              report.success('app-dir exists');
              report.info('copying app-dir to .app');
              dotAppDir = slash("".concat(processDir, "/.app"));
              _context.next = 13;
              return fse.pathExists(dotAppDir);

            case 13:
              dotAppDirExists = _context.sent;

              if (dotAppDirExists) {
                rimraf.sync(dotAppDir);
              }

              _context.next = 17;
              return fse.copy(appDir, dotAppDir);

            case 17:
              _context.next = 19;
              return fse.pathExists(dotAppDir);

            case 19:
              copiedSuccess = _context.sent;

              if (copiedSuccess) {
                report.success('.app dir copied');
              }

              report.info('building chunks');
              buildChunks();
              report.success('chunks built!!!');
              report.info('searching for public directory');
              publicDir = slash("".concat(processDir, "/public"));
              _context.next = 28;
              return fse.pathExists(publicDir);

            case 28:
              publicDirExists = _context.sent;

              if (publicDirExists) {
                report.info('removing public directory');
                rimraf.sync(publicDir);
              }

              _context.next = 32;
              return fse.ensureDir(publicDir);

            case 32:
              report.success('brand new public directory');
              return _context.abrupt("return", true);

            case 34:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function ensureDirs() {
      return _ensureDirs.apply(this, arguments);
    }

    return ensureDirs;
  }();
});