#!/usr/bin/env node

/* eslint-disable no-unused-expressions */

(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define([], factory);
  } else if (typeof exports !== "undefined") {
    factory();
  } else {
    var mod = {
      exports: {}
    };
    factory();
    global.index = mod.exports;
  }
})(this, function () {
  "use strict";

  var cli = require('yargs');

  var start = require('./start');

  var build = require('./build');

  console.clear();
  cli.command({
    command: 'start',
    desc: "\n      Start a development server with HMR\n    ",
    handler: function handler(argv) {
      return start(argv);
    },
    builder: function builder(b) {
      b.option('port', {
        alias: 'p',
        type: 'string',
        default: '3030',
        describe: 'Set development server port. "default: 3030"'
      });
      b.option('routing', {
        alias: 'r',
        type: 'string',
        default: 'htaccess',
        describe: 'Set the routing strategy for your htaccess. "default: htaccess"'
      });
    }
  }).command({
    command: 'build',
    desc: "\n      Build a production ready hybrid app\n    ",
    handler: function handler(argv) {
      return build(argv);
    }
  }).help().argv;
});