(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define([], factory);
  } else if (typeof exports !== "undefined") {
    factory();
  } else {
    var mod = {
      exports: {}
    };
    factory();
    global.babelLoaderOptions = mod.exports;
  }
})(this, function () {
  "use strict";

  module.exports = function babelLoader() {
    var options = {
      presets: ['@babel/preset-react', ['@babel/preset-env', {
        modules: 'umd'
      }]],
      plugins: ['universal-import', '@babel/plugin-transform-regenerator', '@babel/plugin-proposal-class-properties', '@babel/plugin-syntax-dynamic-import', '@babel/plugin-transform-classes'],
      env: {
        development: {
          plugins: ['react-hot-loader/babel']
        }
      }
    };
    return options;
  };
});