(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define([], factory);
  } else if (typeof exports !== "undefined") {
    factory();
  } else {
    var mod = {
      exports: {}
    };
    factory();
    global.webpackDev = mod.exports;
  }
})(this, function () {
  "use strict";

  (function () {
    var enterModule = require('react-hot-loader').enterModule;

    enterModule && enterModule(module);
  })();

  var path = require('path');

  var WriteFilePlugin = require('write-file-webpack-plugin');

  var HtmlWebpackPlugin = require('html-webpack-plugin');

  var webpack = require('webpack');

  var rimraf = require('rimraf');

  var nunjucks = require('nunjucks');

  var fs = require('fs');

  var devTemplatePath = path.join(__dirname, 'dev-template.html');
  var templatePath = path.join(__dirname, '../default-html/index.html');
  rimraf.sync(devTemplatePath);
  var templateString = fs.readFileSync(templatePath).toString();
  var template = nunjucks.renderString(templateString);
  fs.writeFileSync(devTemplatePath, template);
  module.exports = {
    entry: {
      bundle: ['webpack-hot-middleware/client?__webpack_hmr&reload=true&overlay=true', path.join(process.cwd(), '/.app/dev-renderer.js')]
    },
    mode: 'development',
    output: {
      path: path.join(process.cwd(), '/public/'),
      publicPath: '/',
      filename: '[name].js'
    },
    plugins: [new HtmlWebpackPlugin({
      template: path.resolve(devTemplatePath)
    }), new WriteFilePlugin(), new webpack.HotModuleReplacementPlugin()]
  };
  ;

  (function () {
    var reactHotLoader = require('react-hot-loader').default;

    var leaveModule = require('react-hot-loader').leaveModule;

    if (!reactHotLoader) {
      return;
    }

    reactHotLoader.register(devTemplatePath, "devTemplatePath", "/home/martiuh/Sites/chido/src/client-webpack/webpack.dev.js");
    reactHotLoader.register(templatePath, "templatePath", "/home/martiuh/Sites/chido/src/client-webpack/webpack.dev.js");
    reactHotLoader.register(templateString, "templateString", "/home/martiuh/Sites/chido/src/client-webpack/webpack.dev.js");
    reactHotLoader.register(template, "template", "/home/martiuh/Sites/chido/src/client-webpack/webpack.dev.js");
    leaveModule(module);
  })();

  ;
});