(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define([], factory);
  } else if (typeof exports !== "undefined") {
    factory();
  } else {
    var mod = {
      exports: {}
    };
    factory();
    global.wireHtaccess = mod.exports;
  }
})(this, function () {
  "use strict";

  function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

  function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

  function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

  function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

  /* eslint-disable-next-line import/no-unresolved */
  var fs = require('fs');
  /*
    Fulfill these use cases:
    1. /hello/:language/:person (two dynamic params next to each other)
      How to route `/hello/spa` and `/hello/spa/tonatiuh` to its correspondant directory
  */


  module.exports = function wireHtaccess() {
    var currentDir = process.cwd();
    var rawDynamic = fs.readFileSync("".concat(currentDir, "/.app/routes/chido-routes.json"));
    rawDynamic = JSON.parse(rawDynamic.toString());
    console.log(rawDynamic);
    var dynamicArr = Object.values(rawDynamic).filter(function (_ref) {
      var route = _ref.route;
      return !!route;
    });
    console.log(Object.values(rawDynamic));
    var regexString = /[^/]{2,256}$/;
    var lastRegexString = /[^/]{2,256}\/?$/;
    var doubleDotRegex = /:[-a-zA-Z0-9@:%_+.~#?&=]*/;
    var validRoutes = [];
    dynamicArr.forEach(function (_ref2) {
      var route = _ref2.route,
          directory = _ref2.directory;
      var segments = route.split('/');
      segments = segments.map(function (segment, index) {
        if (index === segments.length - 1) {
          return segment.replace(doubleDotRegex, lastRegexString.toString());
        }

        return segment.replace(doubleDotRegex, regexString.toString());
      });
      segments = segments.join('/');
      validRoutes = [].concat(_toConsumableArray(validRoutes), ["RewriteCond %{REQUEST_URI} !=^".concat(segments, "\n      RewriteRule ").concat(segments, " /public/").concat(directory, " [L]")]);
    });
    return validRoutes;
  };
});