(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define([], factory);
  } else if (typeof exports !== "undefined") {
    factory();
  } else {
    var mod = {
      exports: {}
    };
    factory();
    global.index = mod.exports;
  }
})(this, function () {
  "use strict";

  (function () {
    var enterModule = require('react-hot-loader').enterModule;

    enterModule && enterModule(module);
  })();

  var chalk = require('chalk');

  var _console = console,
      log = _console.log;

  var alerter = function alerter(color, type) {
    var msg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
    return log("".concat(chalk[color](type), " ").concat(msg));
  };

  module.exports = {
    success: function success() {
      var msg = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'done';
      return alerter('green', 'success', msg);
    },
    error: function error(msg) {
      return alerter('red', 'error', msg);
    },
    event: function event(msg) {
      return alerter('blue', 'info', msg);
    },
    info: function info(msg) {
      return alerter('blue', 'info', msg);
    },
    failure: function failure(msg) {
      alerter('red', 'FAILURE', msg);
      process.exit(1);
    },
    warn: function warn(msg) {
      return alerter('yellow', 'warning', msg);
    },
    chido: function chido(msg) {
      return alerter('cyan', "[chido] ".concat(msg));
    }
  };
  ;

  (function () {
    var reactHotLoader = require('react-hot-loader').default;

    var leaveModule = require('react-hot-loader').leaveModule;

    if (!reactHotLoader) {
      return;
    }

    reactHotLoader.register(log, "log", "/home/martiuh/Sites/chido/src/report/index.js");
    reactHotLoader.register(alerter, "alerter", "/home/martiuh/Sites/chido/src/report/index.js");
    leaveModule(module);
  })();

  ;
});