(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define([], factory);
  } else if (typeof exports !== "undefined") {
    factory();
  } else {
    var mod = {
      exports: {}
    };
    factory();
    global.routesWebpack = mod.exports;
  }
})(this, function () {
  "use strict";

  // Only one entry point
  var path = require('path');

  var webpack = require('webpack');

  var WriteFilePlugin = require('write-file-webpack-plugin');

  var webpackMerge = require('webpack-merge');

  var sharedConfig = require('../client-webpack/webpack.shared');

  var chidoShared = require('../html-generator/html.shared');

  module.exports = function chidoWebpack(env, argv) {
    var config = {
      target: 'node',
      node: {
        __dirname: false
      },
      mode: 'production',
      entry: path.join(process.cwd(), '/.app/routes/build-hybrid-routes.js'),
      output: {
        filename: 'buildRoutes.js',
        path: path.join(process.cwd(), '/.app/routes/')
      },
      plugins: [new WriteFilePlugin(), new webpack.optimize.LimitChunkCountPlugin({
        maxChunks: 1
      }), new webpack.DefinePlugin({
        IS_SERVER: true,
        'process.env': {
          NODE_ENV: JSON.stringify('production')
        }
      })]
    };
    var shared = sharedConfig(env, argv);
    shared.module.rules = shared.module.rules.filter(function (_ref) {
      var test = _ref.test;
      return String(test) !== String(/\.css$/);
    });
    return webpackMerge.smart(shared, config, chidoShared);
  };
});